//+-------------------------------------------------------------------------------+
//|                                                      ServicesMT4.mqh          |
//|                                                      Copyright  Zhunko       |
//|16.10.2010 - 19.12.2012                               MF ZHUNKO vadim@zhunko.ru|
//+-------------------------------------------------------------------------------+
//|    "ServicesMT4.dll".                               |
//+-------------------------------------------------------------------------------+
//|  "ServicesMT4.dll"  156     4.|
//| ,      ,        |
//|  . : "..." .                |
//+-------------------------------------------------------------------------------+
//
//====   4. ==================================================================================================================================
#define LL_ENGLISH                    0x7D00 // 32000  .
#define LL_ARABIC                     0x7D01 // 32001  .
#define LL_BULGARIAN                  0x7D02 // 32002  .
#define LL_CHINESE_SIMPLE             0x7D03 // 32003  () .
#define LL_CHINESE_TRADITIONAL        0x7D04 // 32004  () .
#define LL_CROATIAN                   0x7D05 // 32005  .
#define LL_CZECH                      0x7D06 // 32006  .
#define LL_DANISH                     0x7D07 // 32007  .
#define LL_DUTCH                      0x7D08 // 32008  .
#define LL_ESTONIAN                   0x7D09 // 32009  .
#define LL_FARSI                      0x7D1A // 32010 .
#define LL_FRENCH                     0x7D1B // 32011  .
#define LL_GERMAN                     0x7D1C // 32012  .
#define LL_GREEK                      0x7D1D // 32013  .
#define LL_HEBREW                     0x7D1E // 32014 .
#define LL_HUNGARIAN                  0x7D1F // 32015  .
#define LL_INDONESIAN                 0x7D10 // 32016  .
#define LL_ITALIAN                    0x7D11 // 32017  .
#define LL_JAPANESE                   0x7D12 // 32018  .
#define LL_KOREAN                     0x7D13 // 32019  .
#define LL_LATVIAN                    0x7D14 // 32020  .
#define LL_LITHUANIAN                 0x7D15 // 32021  .
#define LL_MONGOLIAN                  0x7D16 // 32022  .
#define LL_POLISH                     0x7D17 // 32023  .
#define LL_PORTUGUESE                 0x7D18 // 32024  .
#define LL_RUSSIAN                    0x7D19 // 32025  .
#define LL_SERBIAN                    0x7D1A // 32026  .
#define LL_SLOVAK                     0x7D1B // 32027  .
#define LL_SPANISH                    0x7D1C // 32028  .
#define LL_SWEDISH                    0x7D1D // 32029  .
#define LL_TURKISH                    0x7D1E // 32030  .
#define LL_VIETNAMESE                 0x7D1F // 32031  .
//====     "ServiceLoadingQuotes()". ===========================================================================================
#define MLQ_STOP_TF                        0 //           .
#define MLQ_CONTINUED                      1 //      .
#define MLQ_FINISH                         2 //   .
//====      "ServiceSetViewChart()". =======================================================================================
#define VS_BARS                            0 // .
#define VS_CANDLES                         1 //  .
#define VS_LINE                            2 // .
//====    . =======================================================================================================================
#define PC_OK                         0x0001 //  "OK".
#define PC_CANCEL                     0x0002 //  "".
#define PC_RESET                      0x3021 //  "".
#define PC_TAB_CONTROL                0x3020 //  .
//----  "". ----------------------------------------------------------------------------------------------------------------------------------------
#define PC_COLOR_SCHEME               0x0503 //  .
#define PC_COLOR_BACKGROUND           0x041A // .
#define PC_COLOR_FOREGROUND           0x0421 // .
#define PC_COLOR_GRID                 0x0483 // .
#define PC_COLOR_BAR_UP               0x041C //  .
#define PC_COLOR_BAR_DOWN             0x041B //  .
#define PC_COLOR_BULL_CANDLE          0x041E //  .
#define PC_COLOR_BEAR_CANDLE          0x041D //  .
#define PC_COLOR_LINE_GRAPH           0x049B // .
#define PC_COLOR_LINE_VOLUMES         0x0569 // .
#define PC_COLOR_ASK_LINE             0x03F7 //  ASK.
#define PC_COLOR_STOP_LEVELS          0x0535 //  .
//----  "". ---------------------------------------------------------------------------------------------------------------------------------------
#define PC_COMMON_OFFLINE_CHART       0x04E9 //  .
#define PC_COMMON_FOREGROUND          0x04E4 //  .
#define PC_COMMON_SHIFT               0x04EF //  .
#define PC_COMMON_AUTOSCROLL          0x04ED //  .
#define PC_COMMON_BAR_CHART           0x04E1 //   - .
#define PC_COMMON_CANDLESTICKS        0x04E2 //   -  .
#define PC_COMMON_LINE_CHART          0x04E6 //   - .
#define PC_COMMON_OHLC                0x04EA //  OHLC.
#define PC_COMMON_ASK                 0x04E0 //   ASK.
#define PC_COMMON_PERIOD_SEPARATORS   0x04EE //   .
#define PC_COMMON_GRID                0x04E5 //  .
#define PC_COMMON_VOLUMES             0x04F0 //  .
#define PC_COMMON_OBJECT_DESCRIPTIONS 0x04E3 //   .
#define PC_COMMON_SCALE_FIX_1_TO_1    0x04EC //   1:1.
#define PC_COMMON_SCALE_FIX           0x04EB //  .
#define PC_COMMON_FIXED_MAX           0x04E7 // .
#define PC_COMMON_FIXED_MIN           0x04E8 // .
//
#import "ServicesMT4.dll"
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 1.   .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 1.1.        .       .
 //           .     .
 //             .
 void ServiceInit(int dwProcessID); //  .      NULL.
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 2.       4.
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 2.1.    4.
 //=====================================================================================================================================================================
 // 2.1.1.      4.
 int ServiceBuild();
 //=====================================================================================================================================================================
 // 2.1.2.      4.
 int ServiceGetProcessId();
 //=====================================================================================================================================================================
 // 2.1.3.       4.
 int ServiceHandleMT4();
 //=====================================================================================================================================================================
 // 2.1.4.        4     .
 string ServicePathDirectoryMT4();
 //=====================================================================================================================================================================
 // 2.1.5.         4     .
 string ServicePathServer();
 //=====================================================================================================================================================================
 // 2.1.6.    c   4. : "4.0.0.445".
 string ServiceVersion();
 //=====================================================================================================================================================================
 // 2.1.7.         4   "yyyy.mm.dd".
 string ServiceVersionDate();
 //=====================================================================================================================================================================
 // 2.1.8.          4. : "Version: 4.00  Build 445 (09 Nov 2012)".
 string ServiceVersionFull();
 //=====================================================================================================================================================================
 // 2.2.     4.
 //=====================================================================================================================================================================
 // 2.2.1.     4.   TRUE,     ,  - FALSE.
 bool ServiceMetaTraderClose();
 //=====================================================================================================================================================================
 // 2.2.2.      4.
 void ServiceMetaTraderTitle(int bTitle); //      4. FALSE -   , TRUE -   .
 //=====================================================================================================================================================================
 // 2.2.3.     4.   TRUE,      ,  - FALSE.
 bool ServiceMetaTraderHide();
 //=====================================================================================================================================================================
 // 2.2.4.      4.
 void ServiceMetaTraderHotKeys(int nKey,     //    1.
                               int nKeyMod); //    2.     :
                                             //  VK_SHIFT	     SHIFT.
                                             //  VK_CONTROL	   CTRL.
                                             //  VK_MENU	      ALT.
                                             //  VK_LWIN	       WINDOWS.
                                             //  VK_RWIN	       WINDOWS.
 //=====================================================================================================================================================================
 // 2.2.5.       4.
 void ServiceMetaTraderKeyDown(int nKey); //  .
 //=====================================================================================================================================================================
 // 2.2.6.     4.   TRUE,      ,  - FALSE.
 bool ServiceMetaTraderMaximize();
 //=====================================================================================================================================================================
 // 2.2.7.     4.   TRUE,      ,  - FALSE.
 bool ServiceMetaTraderMinimize();
 //=====================================================================================================================================================================
 // 2.2.8.         4.   TRUE,      ,  - FALSE.
 bool ServiceMetaTraderRestore();
 //=====================================================================================================================================================================
 // 2.2.9.     4.   TRUE,      ,  - FALSE.
 bool ServiceMetaTraderShow();
 //=====================================================================================================================================================================
 // 2.2.10.          4.       4.
 void ServiceSetAccountNumber(int nAccountNumber); //          4.
 //=====================================================================================================================================================================
 // 2.3. , /    4.
 //=====================================================================================================================================================================
 // 2.3.1.    " "  4.
 void ServiceHideDataWindow();
 //=====================================================================================================================================================================
 // 2.3.2.    " "  4.
 void ServiceHideMarketWatch();
 //=====================================================================================================================================================================
 // 2.3.3.    ""  4.
 void ServiceHideNavigator();
 //=====================================================================================================================================================================
 // 2.3.4.    ""  4.
 void ServiceHideTerminal();
 //=====================================================================================================================================================================
 // 2.3.5.    ""  4.
 void ServiceHideTester();
 //=====================================================================================================================================================================
 // 2.3.6.   TRUE,   " "  4 ,  - FALSE.
 bool ServiceIsVisibleDataWindow();
 //=====================================================================================================================================================================
 // 2.3.7.   TRUE,   " "  4 ,  - FALSE.
 bool ServiceIsVisibleMarketWatch();
 //=====================================================================================================================================================================
 // 2.3.8.   TRUE,   ""  4 ,  - FALSE.
 bool ServiceIsVisibleNavigator();
 //=====================================================================================================================================================================
 // 2.3.9.   TRUE,   ""  4 ,  - FALSE.
 bool ServiceIsVisibleTerminal();
 //=====================================================================================================================================================================
 // 2.3.10.   TRUE,   ""  4 ,  - FALSE.
 bool ServiceIsVisibleTester();
 //=====================================================================================================================================================================
 // 2.3.11.    " "  4.
 void ServiceShowDataWindow();
 //=====================================================================================================================================================================
 // 2.3.12.    " "  4.
 void ServiceShowMarketWatch();
 //=====================================================================================================================================================================
 // 2.3.13.    ""  4.
 void ServiceShowNavigator();
 //=====================================================================================================================================================================
 // 2.3.14.    ""  4.
 void ServiceShowTerminal();
 //=====================================================================================================================================================================
 // 2.3.15.    ""  4.
 void ServiceShowTester();
 //=====================================================================================================================================================================
 // 2.4.    4.
 //=====================================================================================================================================================================
 // 2.4.1.       4: LL_ENGLISH -  ;
 //                                                                   LL_RUSSIAN -  .
 int ServiceGetLocalization();
 //=====================================================================================================================================================================
 // 2.4.2.    " ".          " ",  - NULL.
 int ServiceOpenGlobalVariables();
 //=====================================================================================================================================================================
 // 2.4.3.    " ".          " ",  - NULL.
 int ServiceOpenHistoryCenter();
 //=====================================================================================================================================================================
 // 2.4.4.    ""    .          "",
 //         - NULL.
 int ServiceOpenOptions(int nTab); //    "".
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 3.      .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 3.1.    .
 //=====================================================================================================================================================================
 // 3.1.1.  /   .
 void ServiceAutoScroll(int hwndChart); //    ,    .
 //=====================================================================================================================================================================
 // 3.1.2.  /   .      TRUE,  - FALSE.
 bool ServiceShift(int hwndChart); //    ,   / .
 //=====================================================================================================================================================================
 // 3.1.3.  /     .      TRUE,  - FALSE.
 bool ServiceShowGrid(int hwndChart); //    ,   /  .
 //=====================================================================================================================================================================
 // 3.1.4.  /     .      TRUE,  - FALSE.
 bool ServiceShowVolume(int hwndChart); //    ,   /  .
 //=====================================================================================================================================================================
 // 3.2.    .
 //=====================================================================================================================================================================
 // 3.2.1.       .      TRUE,  - FALSE.
 bool ServiceGetAutoScroll(int hwndChart); //    ,     .
 //=====================================================================================================================================================================
 // 3.2.2.    " "   .      TRUE,  - FALSE.
 bool ServiceGetScaleFix(int hwndChart); //    ,     " ".
 //=====================================================================================================================================================================
 // 3.2.3.    "  1:1"   .      TRUE,  - FALSE.
 bool ServiceGetScaleFix1To1(int hwndChart); //    ,     "  1:1".
 //=====================================================================================================================================================================
 // 3.2.4.    " "   .      TRUE,  - FALSE.
 bool ServiceGetForeground(int hwndChart); //    ,     " ".
 //=====================================================================================================================================================================
 // 3.2.5.      .      TRUE,  - FALSE.
 bool ServiceGetOffline(int hwndChart); //    ,     .
 //=====================================================================================================================================================================
 // 3.2.6.      .      TRUE,  - FALSE.
 bool ServiceGetShift(int hwndChart); //    ,     .
 //=====================================================================================================================================================================
 // 3.2.7.      ASK   .      TRUE,  - FALSE.
 bool ServiceGetShowAsk(int hwndChart); //    ,       ASK.
 //=====================================================================================================================================================================
 // 3.2.8.        .      TRUE,  - FALSE.
 bool ServiceGetShowGrid(int hwndChart); //    ,      .
 //=====================================================================================================================================================================
 // 3.2.9.         .      TRUE,  - FALSE.
 bool ServiceGetShowObjectDescript(int hwndChart); //    ,       .
 //=====================================================================================================================================================================
 // 3.2.10.      OHLC   .      TRUE,  - FALSE.
 bool ServiceGetShowOHLC(int hwndChart); //    ,       OHLC.
 //=====================================================================================================================================================================
 // 3.2.11.         .      TRUE,  - FALSE.
 bool ServiceGetShowPeriodSeparators(int hwndChart); //    ,       .
 //=====================================================================================================================================================================
 // 3.2.12.        .      TRUE,  - FALSE.
 bool ServiceGetShowVolume(int hwndChart); //    ,      .
 //=====================================================================================================================================================================
 // 3.2.13.         .
 //             : VS_BARS     ;
 //                                           VS_CANDLES   ;
 //                                           VS_LINE     .
 int ServiceGetViewChart(int hwndChart); //    ,       .
 //=====================================================================================================================================================================
 // 3.3.    .
 //=====================================================================================================================================================================
 // 3.3.1.       .      .
 bool ServiceSetAutoScroll(int hwndChart,  //    ,     .
                           int bProperty); //  : FALSE -  , TRUE -  .
 //=====================================================================================================================================================================
 // 3.3.2.      .      .
 bool ServiceSetOffline(int hwndChart,  //    ,     .
                        int bProperty); //  : FALSE -  , TRUE -  .
 //=====================================================================================================================================================================
 // 3.3.3.      .
 void ServiceSetScale(int    hwndChart, //    ,     " ".
                      double dMaximum,  //  .
                      double dMinimum); //  .
 //=====================================================================================================================================================================
 // 3.3.4.    " "   .      .
 bool ServiceSetScaleFix(int hwndChart,  //    ,     " ".
                         int bProperty); //  : FALSE -  , TRUE -  .
 //=====================================================================================================================================================================
 // 3.3.5.    "  1:1"   .      .
 bool ServiceSetScaleFix1To1(int hwndChart,  //    ,     "  1:1".
                             int bProperty); //  : FALSE -  , TRUE -  .
 //=====================================================================================================================================================================
 // 3.3.6.    " "   .      .
 bool ServiceSetForeground(int hwndChart,  //    ,     " ".
                           int bProperty); //  : FALSE -  , TRUE -  .
 //=====================================================================================================================================================================
 // 3.3.7.      .      .
 bool ServiceSetShift(int hwndChart,  //    ,     .
                      int bProperty); //  : FALSE -  , TRUE -  .
 //=====================================================================================================================================================================
 // 3.3.8.      ASK   .      .
 bool ServiceSetShowAsk(int hwndChart,  //    ,       ASK.
                        int bProperty); //  : FALSE -  , TRUE -  .
 //=====================================================================================================================================================================
 // 3.3.9.        .      .
 bool ServiceSetShowGrid(int hwndChart,  //    ,      .
                         int bProperty); //  : FALSE -  , TRUE -  .
 //=====================================================================================================================================================================
 // 3.3.10.         .      .
 bool ServiceSetShowObjectDescript(int hwndChart,  //    ,       .
                                   int bProperty); //  : FALSE -  , TRUE -  .
 //=====================================================================================================================================================================
 // 3.3.11.      OHLC   .      .
 bool ServiceSetShowOHLC(int hwndChart,  //    ,       OHLC.
                         int bProperty); //  : FALSE -  , TRUE -  .
 //=====================================================================================================================================================================
 // 3.3.12.         .      .
 bool ServiceSetShowPeriodSeparators(int hwndChart,  //    ,       .
                                     int bProperty); //  : FALSE -  , TRUE -  .
 //=====================================================================================================================================================================
 // 3.3.13.        .      .
 bool ServiceSetShowVolume(int hwndChart,  //    ,      .
                           int bProperty); //  : FALSE -  , TRUE -  .
 //=====================================================================================================================================================================
 // 3.3.14.        .      TRUE,  - FALSE.
 bool ServiceSetViewChart(int hwndChart, //    ,      .
                          int nView);    //     : VS_BARS     ;
                                         //                                   VS_CANDLES   ;
                                         //                                   VS_LINE     .
 //=====================================================================================================================================================================
 // 3.4.    .
 //=====================================================================================================================================================================
 // 3.4.1.      .       .
 int ServiceOpenPropertiesChart(int hwndChart,    //   ,     .
                                int nTabControl); //   : 0 - "", 1 - "".
 //=====================================================================================================================================================================
 // 3.4.2.            .
 void ServicePropertiesChartCheckBox(int  hwndChart,       //   ,     .
                                     int  bSet,            //     :
                                                           //   TRUE  -   ,   "dwControlId"  ,
                                                           //              "bProperty";
                                                           //   FALSE -    ,      .
                                     int &apbProperties[], //        .  .
                                                           //  :
                                                           //   DWORD dwControlId;    .
                                                           //   BOOL  bProperty;      .
                                                           //   WORD  wDecimals;        .  .
                                                           //  MQL4-    3-  INT .  
                                                           //         2-  .
                                     int  nCount);         //    .    "apbProperties[]".
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.      .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.1.       .
 //=====================================================================================================================================================================
 // 4.1.1.       .
 void ServiceChartHotKeys(int hwndChart, //   ,     .
                          int nKey,      //    1.
                          int nKeyMod);  //    2.     :
                                         //  VK_SHIFT	     SHIFT.
                                         //  VK_CONTROL	   CTRL.
                                         //  VK_MENU	      ALT.
                                         //  VK_LWIN	       WINDOWS.
                                         //  VK_RWIN	       WINDOWS.
 //=====================================================================================================================================================================
 // 4.1.2.       .      TRUE,  - FALSE.
 bool ServiceChartKeyDown(int hwndChart, //   ,    .
                          int nKey);     //  .
 //=====================================================================================================================================================================
 // 4.1.3.       .      TRUE,  - FALSE.
 bool ServiceChartKeyUp(int hwndChart, //   ,    .
                        int nKey);     //  .
 //=====================================================================================================================================================================
 // 4.2.      .
 //=====================================================================================================================================================================
 // 4.2.1.     .
 void ServiceCloseAllCharts();
 //=====================================================================================================================================================================
 // 4.2.2.     .      TRUE,  - FALSE.
 bool ServiceCloseChart(int hwndChart); //     .
 //=====================================================================================================================================================================
 // 4.2.3.                 .
 int ServiceGetAllHandlesCharts(int &ahwndCharts[], //    .
                                int  nSize);        //   .
 //=====================================================================================================================================================================
 // 4.2.4.       .
 int ServiceGetHandleActiveChart();
 //=====================================================================================================================================================================
 // 4.2.5.             .
 //          ,  ,        .
 int ServiceGetHandleChart(string sSymbol,  //  .
                           int    nPeriod); //    .
 //=====================================================================================================================================================================
 // 4.2.6.                  
 //             .
 int ServiceGetHandlesEqualCharts(string sSymbol,       //  .
                                  int    nPeriod,       //    .
                                  int   &ahwndCharts[], //    .
                                  int    nSize);        //   .
 //=====================================================================================================================================================================
 // 4.2.7.        .      TRUE,  - FALSE.
 bool ServiceIsChart(int hwndChart); //     .
 //=====================================================================================================================================================================
 // 4.2.8.          .      TRUE,  - FALSE.
 bool ServiceIsChartActive(int hwndChart); //     .
 //=====================================================================================================================================================================
 // 4.2.9.      .
 int ServiceNumberCharts();
 //=====================================================================================================================================================================
 // 4.2.10.     .
 void ServiceSetActiveChart(int hwndChart); //     .
 //=====================================================================================================================================================================
 // 4.3.     .
 //=====================================================================================================================================================================
 // 4.3.1.      .      TRUE,  - FALSE.
 bool ServiceDeselectObjects(int hwndChart); //    ,  .
 //=====================================================================================================================================================================
 // 4.3.2.         .
 void ServiceSetBar(int      hwndChart, //    ,   .
                    datetime lTime);    //      .
 //=====================================================================================================================================================================
 // 4.3.3.       .
 void ServiceStepByStep(int hwndChart); //    ,    .
 //=====================================================================================================================================================================
 // 4.3.4.      .
 bool ServiceZoom(int hwndChart, //    ,     .
                  int bZoom);    //    : TRUE  -     ;
                                 //                                       FALSE -     .
 //=====================================================================================================================================================================
 // 4.4.     .
 //=====================================================================================================================================================================
 // 4.4.1.        .
 void ServiceSaveTemplate(int    hwndChart,      //    ,    .
                          string sNameTemplate); //  ,    .
 //=====================================================================================================================================================================
 // 4.4.2.             .
 void ServiceSetTemplateByName(int    hwndChart,      //    ,   .
                               string sNameTemplate); //     .
 //=====================================================================================================================================================================
 // 4.4.3.             .      TRUE,  - FALSE.
 bool ServiceSetTemplateByNumber(int hwndChart,  //    ,   .
                                 int nTemplate); //     .      .    64.
 //=====================================================================================================================================================================
 // 4.5.       .
 //=====================================================================================================================================================================
 // 4.5.1.          .
 void ServiceSetTimeframeByName(int    hwndChart, //    ,    .
                                string sName);    //   : "M1"    1 ;
                                                  //                          "M5"    5 ;
                                                  //                          "M15"  15 ;
                                                  //                          "M30"  30 ;
                                                  //                          "H1"    1 ;
                                                  //                          "H4"    4 ;
                                                  //                          "D1"    1 ;
                                                  //                          "W1"    1 ;
                                                  //                          "MN1"   1 .
 //=====================================================================================================================================================================
 // 4.5.2.          .
 void ServiceSetTimeframeByNumber(int hwndChart,   //    ,    .
                                  int nTimeFrame); //     0  8.
 //=====================================================================================================================================================================
 // 4.5.3.          .
 void ServiceSetTimeframeByPeriod(int hwndChart, //    ,    .
                                  int nPeriod);  //   : PERIOD_M1       1  1 ;
                                                 //                             PERIOD_M5       5  5 ;
                                                 //                             PERIOD_M15     15  15 ;
                                                 //                             PERIOD_M30     30  30 ;
                                                 //                             PERIOD_H1      60  1 ;
                                                 //                             PERIOD_H4     240  4 ;
                                                 //                             PERIOD_D1    1440  1 ;
                                                 //                             PERIOD_W1   10080  1 ;
                                                 //                             PERIOD_MN1  43200  1 .
 //=====================================================================================================================================================================
 // 4.5.4.    /      .
 void ServiceSetToolChartNamePeriod(int    hwndChart,     //    ,    .
                                    string szSymbol,      //     " ".    ,   .
                                    string szNamePeriod); //   .    ,   .
                                                          //  : "M1"    1 ;
                                                          //                     "M5"    5 ;
                                                          //                     "M15"  15 ;
                                                          //                     "M30"  30 ;
                                                          //                     "H1"    1 ;
                                                          //                     "H4"    4 ;
                                                          //                     "D1"    1 ;
                                                          //                     "W1"    1 ;
                                                          //                     "MN1"   1 .
 //=====================================================================================================================================================================
 // 4.5.5.    /      .
 void ServiceSetToolChartNumberPeriod(int    hwndChart,   //    ,    .
                                      string sSymbol,     //     " ".    ,   .
                                      int    nTimeFrame); //     0  8.    ,   .
 //=====================================================================================================================================================================
 // 4.5.6.    /      .
 void ServiceSetToolChartPeriod(int    hwndChart, //    ,    .
                                string szSymbol,  //     " ".    ,   .
                                int    nPeriod);  //   .    ,   .
                                                  //  : PERIOD_M1       1   1 ;
                                                  //                     PERIOD_M5       5   5 ;
                                                  //                     PERIOD_M15     15  15 ;
                                                  //                     PERIOD_M30     30  30 ;
                                                  //                     PERIOD_H1      60   1 ;
                                                  //                     PERIOD_H4     240   4 ;
                                                  //                     PERIOD_D1    1440   1 ;
                                                  //                     PERIOD_W1   10080   1 ;
                                                  //                     PERIOD_MN1  43200   1 .
 //=====================================================================================================================================================================
 // 4.6.       .
 //=====================================================================================================================================================================
 // 4.6.1.           .
 void ServiceCloseCmd(int hwndChart); //    ,     .
 //=====================================================================================================================================================================
 // 4.6.2.        .
 void ServiceClearCmd(int hwndChart); //    ,      .
 //=====================================================================================================================================================================
 // 4.6.3.       ,    ,      ,     .
 //              .
 int ServiceCreatCmd(int hwndChart); //    ,     .
 //=====================================================================================================================================================================
 // 4.6.4.         .    ,   TRUE,  - FALSE.
 bool ServiceIsCmd(int hwndChart); //    ,      .
 //=====================================================================================================================================================================
 // 4.6.5.         .    ,   TRUE.
 //                 FALSE.
 bool ServiceIsVisibleCmd(int hwndChart); //    ,      .
 //=====================================================================================================================================================================
 // 4.6.6.         .       .
 int ServiceOpenCmd(int hwndChart); //    ,     .
 //=====================================================================================================================================================================
 // 4.6.7.        .
 string ServiceReadCmd(int hwndChart); //    ,       .
 //=====================================================================================================================================================================
 // 4.6.8.         .
 void ServiceWriteCmd(int    hwndChart, //    ,     .
                      string sText);    //     .
 //=====================================================================================================================================================================
 // 4.7.     .
 //=====================================================================================================================================================================
 // 4.7.1.        .    ,      .
 //           "ServiceStopRefreshChart()"  "ServiceStopRefreshAllCharts()"   .
 void ServiceRefreshAllCharts(int nPeriodMilliSec); //     .
 //=====================================================================================================================================================================
 // 4.7.2.      .          .
 void ServiceRefreshAllOnceCharts();
 //=====================================================================================================================================================================
 // 4.7.3.        .    ,       .
 //           "ServiceStopRefreshChart()"  "ServiceStopRefreshAllCharts()"   .
 void ServiceRefreshChart(int hwndChart,        //    .
                          int nPeriodMilliSec); //     .
 //=====================================================================================================================================================================
 // 4.7.4.     .
 void ServiceStopRefreshChart(int hwndChart); //   ,    .
 //=====================================================================================================================================================================
 // 4.7.5.        bTerminate = FALSE,     .
 void ServiceStopRefreshAllCharts(int bTerminate); //      .
                                                   // FALSE -   , TRUE -   .
 //=====================================================================================================================================================================
 // 4.7.6.        .
 void ServiceTickExpert(int hwndChart); //    ,     .
 //=====================================================================================================================================================================
 // 4.7.7.        .
 void ServiceTickIndicators(int hwndChart); //    ,     .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.      " ".
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.1.         " "    .      -1.
 int ServiceGetAllSymbols(string &asSymbols[],   //         " ".
                                                 //         !
                                                 //       MQL4.
                          int     nSizeSymbols); //     .
 //=====================================================================================================================================================================
 // 5.2.       " ".      -1.
 int ServiceGetNumberTools();
 //=====================================================================================================================================================================
 // 5.3.       " "    .    ,   -1.
 int ServiceLineBySymbol(string sSymbol); //     " ".
 //=====================================================================================================================================================================
 // 5.4.     ,    " "   ,     .
 //      ,   ,     ,  - NULL.
 //       .
 int ServiceOpenChart(string sSymbol); //     " ".
 //=====================================================================================================================================================================
 // 5.5.     ,    nLine  " ".
 //      ,   ,     ,  - NULL.
 //             ,    NULL    .
 int ServiceOpenChartByNumber(int    nLine,      //     " ".
                              string sBufSymbol, //       ,     .
                              int    nSizeBuf);  //  .
 //=====================================================================================================================================================================
 // 5.6.     ,    " "   ,       .
 //      ,   ,     ,  - NULL.  .
 int ServiceOpenChartSetNumberTf(string sSymbol,     //     " ".
                                 int    nTimeFrame); //     0  8.
 //=====================================================================================================================================================================
 // 5.7.     ,    " "   ,    .
 //      ,   ,     ,  - NULL.  .
 int ServiceOpenChartSetPeriod(string sSymbol,  //     " ".
                               int    nPeriod); //   .        .
                                                //   PERIOD_M1       1   1 ;
                                                //   PERIOD_M5       5   5 ;
                                                //   PERIOD_M15     15  15 ;
                                                //   PERIOD_M30     30  30 ;
                                                //   PERIOD_H1      60   1 ;
                                                //   PERIOD_H4     240   4 ;
                                                //   PERIOD_D1    1440   1 ;
                                                //   PERIOD_W1   10080   1 ;
                                                //   PERIOD_MN1  43200   1 .
 //=====================================================================================================================================================================
 // 5.8.     ,    " "   ,      .
 //      ,   ,     ,  - NULL.  .
 int ServiceOpenChartSetTf(string sSymbol,     //     " ".
                           string sTimeFrame); //   : ""         NULL     .
                                               //                          "M1"    1 ;
                                               //                          "M5"    5 ;
                                               //                          "M15"  15 ;
                                               //                          "M30"  30 ;
                                               //                          "H1"    1 ;
                                               //                          "H4"    4 ;
                                               //                          "D1"    1 ;
                                               //                          "W1"    1 ;
                                               //                          "MN1"   1 .
 //=====================================================================================================================================================================
 // 5.9.          " ".
 string ServiceSymbolByLine(int nLine); //     " ".
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 6.      "".
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 6.1.     "".
 //=====================================================================================================================================================================
 // 6.1.1.      ""   .
 void ServiceSetTerminalTabByNumber(int nTabId); //    "".
 //=====================================================================================================================================================================
 // 6.1.2.      ""   .
 void ServiceSetTerminalTabByName(string sNameTab); //    "".
 //=====================================================================================================================================================================
 // 6.2.    " ".
 //=====================================================================================================================================================================
 // 6.2.1.          .
 //          TRUE,     ,  - FALSE.
 bool ServiceMailboxCloseByHandle(int hwndMail); //    .
 //=====================================================================================================================================================================
 // 6.2.2.        .
 //          TRUE,     ,  - FALSE.
 bool ServiceMailboxCloseByName(string sTitleMail); //  .
 //=====================================================================================================================================================================
 // 6.2.3.            " "  "".
 //             TRUE,  - FALSE.
 bool ServiceMailboxDelete(int nLine); //    " "  "".
 //=====================================================================================================================================================================
 // 6.2.4.         " "  ""   .
 string ServiceMailboxGetFrom(int nLine); //    " "  "".
 //=====================================================================================================================================================================
 // 6.2.5.            ( )   " "  ""
 //         ,     .   -1,    .
 int ServiceMailboxGetLine(string sDataTime, //    "YYYY.MM.DD HH:MM".           .
                           string sFrom,     //   .       .
                           string sTheme,    //  .       .
                           int    nStart,    //      ( ),     .    .
                           int    nCount);   //    .    -1,     .
 //=====================================================================================================================================================================
 // 6.2.6.        " "  ""        "YYYY.MM.DD HH:MM".
 string ServiceMailboxGetStringTime(int nLine); //    " "  "".
 //=====================================================================================================================================================================
 // 6.2.7.        " "  ""      UNIXTIME.
 datetime ServiceMailboxGetTime(int nLine); //    " "  "".
 //=====================================================================================================================================================================
 // 6.2.8.        " "  ""   .
 string ServiceMailboxGetTheme(int nLine); //    " "  "".
 //=====================================================================================================================================================================
 // 6.2.9.               .
 int ServiceMailboxOpen(int nLine); //    " "  "".
 //=====================================================================================================================================================================
 // 6.2.10.             .
 string ServiceMailboxReadText(int hwndMail); //    ,   MailboxOpen().
 //=====================================================================================================================================================================
 // 6.2.11.   HTML           .
 string ServiceMailboxReadHTML(int hwndMail); //    ,   MailboxOpen().
 //=====================================================================================================================================================================
 // 6.2.12.      .
 int ServiceMailboxSize();
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 7.     MQL4.
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 7.1.      .      TRUE,  - FALSE.
 bool ServiceDeleteExpert(int hwndChart); //    ,  .
 //=====================================================================================================================================================================
 // 7.2.         .
 void ServiceDeleteIndicatorsByName(int     hwndChart,         //   ,   .
                                    int     nWindow,           //     .  -1,      .
                                    string &asIndicatorName[], //      .
                                    int     nNumberName);      //     .
 //=====================================================================================================================================================================
 // 7.3.      .      TRUE,  - FALSE.
 bool ServiceDeleteScript(int hwndChart); //    ,  .
 //=====================================================================================================================================================================
 // 7.4.              ,   ,
 //       - NULL.        .
 int ServiceDialogScript(int bInstruction); //      : TRUE -  , FALSE -   .
 //=====================================================================================================================================================================
 // 7.5.        .
 //                 "nWindow",  .
 int ServiceGetNamesIndicators(int     hwndChart,         //   ,   .
                               int     nWindow,           //  .  -1,       .
                               string &asIndicatorName[], //       .
                                                          //         !
                                                          //       MQL4.
                               int     nNumberName);      //   "asIndicatorName[]"    .
 //=====================================================================================================================================================================
 // 7.6.   TRUE,     ,  - FALSE.
 bool ServiceIsPropertiesExpert(string sNameExpert); //  ,     .
 //=====================================================================================================================================================================
 // 7.7.     .
 bool ServiceListIndicators(int hwndChart); //    ,      .
 //=====================================================================================================================================================================
 // 7.8.          .
 void ServiceLoadCustomIndicator(int    hwndChart,       //    ,   .
                                 string szNameIndicator, //   .
                                 int    bOK);            //   ,      .
                                                         // TRUE -    "OK" , FALSE -    "OK" .
 //=====================================================================================================================================================================
 // 7.9.         .
 void ServiceLoadExpert(int    hwndChart,    //    ,   .
                        string szNameExpert, //   .
                        int    bOK);         //   ,      .
                                             // TRUE -    "OK" , FALSE -    "OK" .
 //=====================================================================================================================================================================
 // 7.10.         .
 void ServiceLoadScript(int    hwndChart,    //    ,   .
                        string szNameScript, //   .
                        int    bOK);         //   ,      .      !
                                             //               -
                                             //        .
                                             // TRUE -    "OK" , FALSE -    "OK" .
 //=====================================================================================================================================================================
 // 7.11.          .
 void ServiceLoadStdIndicator(int    hwndChart,       //    ,   .
                              string szNameIndicator, //   .
                              int    bOK);            //   ,      .
                                                      // TRUE -    "OK" , FALSE -    "OK" .
 //=====================================================================================================================================================================
 // 7.12.     .      TRUE,  - FALSE.
 bool ServicePropertiesExpert(int hwndChart); //    ,      .
 //=====================================================================================================================================================================
 // 7.13.  / ,   "".
 void ServiceSetExperts();
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 8.  .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 8.1.   ,     ,   ,     ,  ,
 //         .
 //          ,     ,      ,    .
 void ServiceGetCursorInfo(int &aiCursorInfo[], //    .
                                                // aiCursorInfo[0] -   ,   .
                                                // aiCursorInfo[1] -   X .
                                                // aiCursorInfo[2] -   Y .
                                                // aiCursorInfo[3] -   X .
                                                // aiCursorInfo[4] -   Y .
                                                // aiCursorInfo[5] -  ,    .
                                                //                      -1  0xFFFFFFFF,       .
                           int  nSize);         //  .
 //=====================================================================================================================================================================
 // 8.2.     (     )  .
 string ServiceGetNameServer();
 //=====================================================================================================================================================================
 // 8.3.      "HOME"           " ".
 //           0,    1.      -1   .
 //       szNameScript      .      nLoading, bMode, abScanTF  
 //      .  bMode, abScanTF      nLoading = MLQ_CONTINUED.
 int ServiceLoaderQuotes(int    nLoading,      //   :
                                               //  MLQ_STOP_TF              
                                               //                       "bMode";
                                               //  MLQ_CONTINUED       ;
                                               //  MLQ_FINISH       .
                         int    bMode,         //   :
                                               // TRUE  -        ;
                                               // FALSE -        .
                         int    abScanTF[9],   //     .       9 .
                         string szNameScript); //  -             .
 //=====================================================================================================================================================================
 // 8.4.   ,    .
 void ServiceLogin(int    nLogin,      //  .      (nLogin = 0),     --.
                   string sPassword,   // .       ,     .
                   string sNameServer, //  .        ,     .
                   int    bStoreInfo); //    - TRUE.     - FALSE.
 //=====================================================================================================================================================================
 // 8.5.          .
 int ServiceOpenDeletetChart(int nChart); //      .
 //=====================================================================================================================================================================
 // 8.6.     . ,   ,     ,  - NULL.
 int ServiceOpenOfflineChart(string sSymbol,  //  .
                             string sPeriod); // . : M1, M2, M5, H1, H12, Daily, Weekly, Monthly, D90, D360, D1440.
 //=====================================================================================================================================================================
 // 8.7.   .      TRUE,  - FALSE.
 bool ServiceRescanServers();
 //=====================================================================================================================================================================
 // 8.8.        "ServiceLoaderQuotes()".
 //              ,      .
 void ServiceSensorLoadQuotes(int hwndChart); //    ,     .
 //=====================================================================================================================================================================
#import
//
/*
07.11.2010.  0.11.7.1.
1.  ServiceNoAutoScroll()   ServiceAutoScroll().
2.  ServiceSetActiveChart()   ServiceActiveChart(). 
3.   .
4.         H1.
5.          VOID.
6.   ServiceOpenChart()     .
7.   ServiceDeleteIndicatorsByName(), ServiceHotKeysChart(), ServiceIsChart(), ServiceKeyChart(), ServiceKeyTerminal(), ServiceLogin(), ServiceNumberTools(), ServiceOpenChartByNumber(), ServiceOpenChartByName(), ServiceOpenOfflineChart().

08.11.2010.  0.11.8.3.
1.   ServiceGetAllSymbols().    .   .     .
2.   .

01.12.2010.  0.12.1.1.
1.    .    .
2.  "".              (         !!!).    .   !
3.    ServiceActiveChart()  ServiceSetActiveChart().
4.    ServiceNumberTools()  ServiceGetNumberTools(). 
5.   ServiceGetNameServer(), ServiceOpenDeletetChart(), ServiceSetTemplateByName(), ServiceSetTemplateByNumber().

05.12.2010.  0.12.5.1. 
1.   ServiceTerminalClose(), ServiceTerminalHide(), ServiceTerminalMaximize(), ServiceTerminalMinimize(), ServiceTerminalRestore(), ServiceTerminalShow(), ServiceLoadingQuotes().
2.       ServiceOpenChartByNumber().

06.12.2010.  0.12.6.1.
1.      .     .     .

09.02.2011.  1.2.9.1.
1.   ServiceDeinit(), ServiceInit(), ServiceGetLocalization(), ServiceSensorLoadQuotes(). 
2.           : ServiceLoadCustomIndicator(), ServiceLoadExpert(), ServiceLoadScript(), ServiceLoadStdIndicator().
3.        Windows XP.
4.       .

05.04.2011.  1.4.5.1.
1.  : ServiceOpenGlobalVariables(), ServiceOpenHistoryCenter(), ServiceOpenOptions(),
                      ServiceShift(), ServiceShowGrid(), ServiceShowVolume(), ServiceGetAutoScroll(), ServiceGetScaleFix(), ServiceGetScaleFix1To1(),
                      ServiceGetForeground(), ServiceGetOffline(), ServiceGetShift(), ServiceGetShowAsk(), ServiceGetShowGrid(), ServiceGetShowObjectDescript(), ServiceGetShowOHLC(), ServiceGetShowPeriodSeparators(), ServiceGetShowVolume(), ServiceGetViewChart(),
                      ServiceSetAutoScroll(), ServiceSetOffline(), ServiceSetScale(), ServiceSetScaleFix(), ServiceSetScaleFix1To1(), ServiceSetForeground(), ServiceSetShift(), ServiceSetShowAsk(), ServiceSetShowGrid(), ServiceSetShowObjectDescript(),
                      ServiceSetShowOHLC(), ServiceSetShowPeriodSeparators(), ServiceSetShowVolume(), ServiceSetViewChart(),
                      ServiceOpenPropertiesChart(), ServicePropertiesChartCheckBox(), ServiceStepByStep(), ServiceGetNamesIndicators().
2.  : ServiceOpenChartByName(), ServiceListIndicators(), ServiceDeleteIndicatorsByName(), ServiceAutoScroll().
3.       4 (392).
4.      ServiceLogin().

03.05.2011.  1.5.3.1.
1.  : ServiceGetPathTerminal(), ServiceGetAllHandlesCharts(), ServiceSetToolChartNamePeriod(), ServiceSetToolChartNumberPeriod(), ServiceSetToolChartPeriod(). 
2.     ServiceOpenChartByNumber().

05.10.2011.  1.10.5.1.
1.  : ServiceHideDataWindow(), ServiceHideMarketWatch(), ServiceHideNavigator(), ServiceHideTerminal(), ServiceHideTester(),
                      ServiceShowDataWindow(), ServiceShowMarketWatch(), ServiceShowNavigator(), ServiceShowTerminal(), ServiceShowTester(), ServiceIsChartActive(), ServiceChartKeyUp(), ServiceSetTerminalTabByNumber(), ServiceSetTerminalTabByName(), ServiceMailboxCloseByHandle(),
                      ServiceMailboxCloseByName(), ServiceMailboxDelete(), ServiceMailboxGetFrom(), ServiceMailboxGetLine(), ServiceMailboxGetStringTime(), ServiceMailboxGetTime(), ServiceMailboxGetTheme(), ServiceMailboxOpen(), ServiceMailboxReadText(), ServiceMailboxReadHTML(),
                      ServiceCloseCmd(), ServiceIsVisibleCmd(), ServiceOpenCmd(), ServiceReadCmd(), ServiceWriteCmd(),
                      ServiceRefreshAllCharts(), ServiceRefreshAllOnceCharts(), ServiceRefreshChart(), ServiceStopRefreshChart(), ServiceStopRefreshAllCharts(),
                      ServiceHandleMT4(), ServiceSetAccountNumber(), ServiceGetCursorPos().
2.  : ServiceGetPathTerminal(), ServiceTerminalClose(), ServiceTerminalHide(), ServiceTerminalMaximize(), ServiceTerminalMinimize(), ServiceTerminalRestore(), ServiceTerminalShow(), ServiceHotKeysTerminal(), ServiceKeyTerminal(), ServiceHotKeysChart(), ServiceKeyChart().
    : ServiceGetPathMT4(), ServiceMetaTraderClose(), ServiceMetaTraderHide(), ServiceMetaTraderMaximize(), ServiceMetaTraderMinimize(), ServiceMetaTraderRestore(), ServiceMetaTraderShow(), ServiceMetaTraderHotKeys(), ServiceMetaTraderKeyDown(), ServiceChartHotKeys(), ServiceChartKeyDown().
3.      VOID  BOOL : ServiceMetaTraderClose(), ServiceMetaTraderHide(), ServiceMetaTraderMaximize(), ServiceMetaTraderMinimize(), ServiceMetaTraderRestore(), ServiceMetaTraderShow().
4.      ServiceSymbolByLine()  .
5.    : ServicePropertiesChartCheckBox(), ServiceSetTemplateByName().

05.10.2011.  1.11.22.1.
1.     ServiceDeleteIndicatorsByName()      .
2.       MQL4 : ServiceLoadCustomIndicator(), ServiceLoadExpert(), ServiceLoadScript(), ServiceLoadStdIndicator().
3.              409.

11.03.2012.  2.3.11.2.
1.     4 416      .
2.     10 .
3.         .
4.  : ServiceGetProcessId(); ServiceMetaTraderTitle(), ServiceNumberCharts().

04.04.2012.  2.4.4.1.
1.        (  4.7.).         .

17.07.2012.  2.7.17.1.
1.  : ServiceGetPathServer().
2.   ServiceGetPathMT4()  ServiceGetPathDirectoryMT4().

22.09.2012.  2.9.22.3.
1.     4 438      .
2.      4.

05.10.2012.  2.10.22.1.
1.    4.2 : ServiceGetHandleActiveChart(), ServiceGetHandleChart(), ServiceGetHandlesEqualCharts().
2.    ServiceOpenChartByName()  ServiceOpenChartSetTf().
3.    5 : ServiceOpenChart(), ServiceOpenChartSetNumberTf(), ServiceOpenChartSetPeriod().
4.         : ServiceLoadCustomIndicator(), ServiceLoadExpert(), ServiceLoadScript(), ServiceLoadStdIndicator().
5.      BOOL  VOID  : ServiceLoadCustomIndicator(), ServiceLoadExpert(), ServiceLoadScript(), ServiceLoadStdIndicator().

30.10.2012.  2.10.30.1.
1.   ServiceOpenChartByNumber().        ,    NULL    .
2.    4.4  ServiceSaveTemplate().

11.11.2012.  2.11.11.1.
1.   .
2.      ServiceSaveTemplate().
3.     4 445.
4.      .
5.   ServiceGetPathDirectoryMT4(), ServiceGetPathServer()   ServicePathDirectoryMT4(), ServicePathServer().
6.    2.1 : ServiceBuild(), ServiceVersion(), ServiceVersionDate().
7.      4.7: ServiceRefreshAllCharts(), ServiceRefreshAllOnceCharts(), ServiceRefreshChart().

13.11.2012.  2.11.13.1.
1.  ServiceVersion()    : "4.0.0.445".
2.   2.1   ServiceVersionFull(),    : "Version: 4.00  Build 445 (09 Nov 2012)".
3.      .  " "      .

16.11.2012.  2.11.16.1.
1.    Windows XP.

19.12.2012.  2.12.19.2.
1.   2   ServiceIsPropertiesExpert(),       .

11.02.2013.  3.02.11.7.
1.          ServiceGetHandleChart(), ServiceGetHandlesEqualCharts().
*/